From ae824e838aeb679dba3a538868f75980d4a0d645 Mon Sep 17 00:00:00 2001
From: Thomas Munro <thomas.munro@gmail.com>
Date: Mon, 9 Feb 2026 20:25:18 +1300
Subject: [PATCH v1] Remove MULE_INTERNAL encoding.

This was useful before widespread Unicode adoption, and was based on the
internal encoding Emacs used to mix multiple sub-encodings.  Emacs
itself has stopped using it, and our implementation hadn't been updated
with modern underlying standards.  It is thought to be very unlikely
that anyone is still using it in the field.  Since such a complex
encoding comes with costs and risks, we agreed to drop support.

Any existing database using this encoding would need to be dumped and
restored with a new encoding to upgrade to PostgreSQL 19, most likely
UTF8, since pg_upgrade would fail.

Reviewed-by: Tom Lane <tgl@sss.pgh.pa.us>
Reviewed-by: Tatsuo Ishii <ishii@postgresql.org>
Discussion: https://postgr.es/m/CA%2BhUKGKXDXh-FdU0orjfv%2BF08f%3DD91BhV3Ra-4zL-q%2BJmGYqTA%40mail.gmail.com
---
 doc/src/sgml/charset.sgml                     | 191 +-------
 src/backend/utils/mb/conv.c                   | 238 ----------
 .../utils/mb/conversion_procs/Makefile        |   4 +-
 .../{latin_and_mic => cyrillic}/Makefile      |   8 +-
 .../cyrillic.c}                               | 144 +-----
 .../cyrillic_and_mic/Makefile                 |  13 -
 .../conversion_procs/euc_cn_and_mic/Makefile  |  13 -
 .../euc_cn_and_mic/euc_cn_and_mic.c           | 169 -------
 .../euc_jp_and_sjis/euc_jp_and_sjis.c         | 448 +-----------------
 .../conversion_procs/euc_kr_and_mic/Makefile  |  13 -
 .../euc_kr_and_mic/euc_kr_and_mic.c           | 177 -------
 .../conversion_procs/euc_tw_and_big5/big5.c   |   3 +-
 .../euc_tw_and_big5/euc_tw_and_big5.c         | 356 +-------------
 .../latin2_and_win1250/latin2_and_win1250.c   |  70 ---
 .../latin_and_mic/latin_and_mic.c             | 139 ------
 .../utils/mb/conversion_procs/meson.build     |   5 +-
 src/backend/utils/mb/mbutils.c                |   6 +-
 src/common/encnames.c                         |   8 -
 src/common/wchar.c                            | 223 ---------
 src/include/catalog/pg_conversion.dat         |  90 ----
 src/include/catalog/pg_proc.dat               | 174 +------
 src/include/mb/pg_wchar.h                     | 198 +-------
 src/pl/plpython/plpy_util.c                   |   4 +-
 src/test/mb/expected/mule_internal.out        | 333 -------------
 src/test/mb/mbregress.sh                      |   2 +-
 src/test/mb/sql/mule_internal.sql             |  72 ---
 src/test/modules/test_escape/test_escape.c    |   2 -
 src/test/regress/expected/conversion.out      | 127 -----
 src/test/regress/expected/encoding.out        |  17 +-
 src/test/regress/expected/object_address.out  |   4 +-
 src/test/regress/expected/xml.out             |   4 +-
 src/test/regress/expected/xml_1.out           |   4 +-
 src/test/regress/expected/xml_2.out           |   4 +-
 src/test/regress/regress.c                    |   2 +
 src/test/regress/sql/conversion.sql           |  27 --
 src/test/regress/sql/encoding.sql             |  11 +-
 src/test/regress/sql/object_address.sql       |   2 +-
 src/test/regress/sql/xml.sql                  |   4 +-
 38 files changed, 55 insertions(+), 3254 deletions(-)
 rename src/backend/utils/mb/conversion_procs/{latin_and_mic => cyrillic}/Makefile (57%)
 rename src/backend/utils/mb/conversion_procs/{cyrillic_and_mic/cyrillic_and_mic.c => cyrillic/cyrillic.c} (80%)
 delete mode 100644 src/backend/utils/mb/conversion_procs/cyrillic_and_mic/Makefile
 delete mode 100644 src/backend/utils/mb/conversion_procs/euc_cn_and_mic/Makefile
 delete mode 100644 src/backend/utils/mb/conversion_procs/euc_cn_and_mic/euc_cn_and_mic.c
 delete mode 100644 src/backend/utils/mb/conversion_procs/euc_kr_and_mic/Makefile
 delete mode 100644 src/backend/utils/mb/conversion_procs/euc_kr_and_mic/euc_kr_and_mic.c
 delete mode 100644 src/backend/utils/mb/conversion_procs/latin_and_mic/latin_and_mic.c
 delete mode 100644 src/test/mb/expected/mule_internal.out
 delete mode 100644 src/test/mb/sql/mule_internal.sql

diff --git a/doc/src/sgml/charset.sgml b/doc/src/sgml/charset.sgml
index 3aabc798012..2895fd43f86 100644
--- a/doc/src/sgml/charset.sgml
+++ b/doc/src/sgml/charset.sgml
@@ -2045,15 +2045,6 @@ ORDER BY c COLLATE ebcdic;
          <entry>1</entry>
          <entry><literal>ISO885916</literal></entry>
         </row>
-        <row>
-         <entry><literal>MULE_INTERNAL</literal></entry>
-         <entry>Mule internal code</entry>
-         <entry>Multilingual Emacs</entry>
-         <entry>Yes</entry>
-         <entry>No</entry>
-         <entry>1&ndash;4</entry>
-         <entry></entry>
-        </row>
         <row>
          <entry><literal>SJIS</literal></entry>
          <entry>Shift JIS</entry>
@@ -2205,7 +2196,7 @@ ORDER BY c COLLATE ebcdic;
      <para>
       Not all client <acronym>API</acronym>s support all the listed character sets. For example, the
       <productname>PostgreSQL</productname>
-      JDBC driver does not support <literal>MULE_INTERNAL</literal>, <literal>LATIN6</literal>,
+      JDBC driver does not support <literal>LATIN6</literal>,
       <literal>LATIN8</literal>, and <literal>LATIN10</literal>.
      </para>
 
@@ -2463,14 +2454,12 @@ RESET client_encoding;
        <row>
         <entry><literal>EUC_CN</literal></entry>
         <entry><emphasis>EUC_CN</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
        <row>
         <entry><literal>EUC_JP</literal></entry>
         <entry><emphasis>EUC_JP</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>SJIS</literal>,
         <literal>UTF8</literal>
         </entry>
@@ -2485,7 +2474,6 @@ RESET client_encoding;
        <row>
         <entry><literal>EUC_KR</literal></entry>
         <entry><emphasis>EUC_KR</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
@@ -2493,7 +2481,6 @@ RESET client_encoding;
         <entry><literal>EUC_TW</literal></entry>
         <entry><emphasis>EUC_TW</emphasis>,
         <literal>BIG5</literal>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
@@ -2511,7 +2498,6 @@ RESET client_encoding;
         <entry><literal>ISO_8859_5</literal></entry>
         <entry><emphasis>ISO_8859_5</emphasis>,
         <literal>KOI8R</literal>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>,
         <literal>WIN866</literal>,
         <literal>WIN1251</literal>
@@ -2544,7 +2530,6 @@ RESET client_encoding;
         <entry><literal>KOI8R</literal></entry>
         <entry><emphasis>KOI8R</emphasis>,
         <literal>ISO_8859_5</literal>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>,
         <literal>WIN866</literal>,
         <literal>WIN1251</literal>
@@ -2559,14 +2544,12 @@ RESET client_encoding;
        <row>
         <entry><literal>LATIN1</literal></entry>
         <entry><emphasis>LATIN1</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
        <row>
         <entry><literal>LATIN2</literal></entry>
         <entry><emphasis>LATIN2</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>,
         <literal>WIN1250</literal>
         </entry>
@@ -2574,14 +2557,12 @@ RESET client_encoding;
        <row>
         <entry><literal>LATIN3</literal></entry>
         <entry><emphasis>LATIN3</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
        <row>
         <entry><literal>LATIN4</literal></entry>
         <entry><emphasis>LATIN4</emphasis>,
-        <literal>MULE_INTERNAL</literal>,
         <literal>UTF8</literal>
         </entry>
        </row>
@@ -2621,23 +2602,6 @@ RESET client_encoding;
         <literal>UTF8</literal>
         </entry>
        </row>
-       <row>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><emphasis>MULE_INTERNAL</emphasis>,
-         <literal>BIG5</literal>,
-         <literal>EUC_CN</literal>,
-         <literal>EUC_JP</literal>,
-         <literal>EUC_KR</literal>,
-         <literal>EUC_TW</literal>,
-         <literal>ISO_8859_5</literal>,
-         <literal>KOI8R</literal>,
-         <literal>LATIN1</literal> to <literal>LATIN4</literal>,
-         <literal>SJIS</literal>,
-         <literal>WIN866</literal>,
-         <literal>WIN1250</literal>,
-         <literal>WIN1251</literal>
-        </entry>
-       </row>
        <row>
         <entry><literal>SJIS</literal></entry>
         <entry><emphasis>not supported as a server encoding</emphasis>
@@ -2668,7 +2632,6 @@ RESET client_encoding;
         <entry><emphasis>WIN866</emphasis>,
          <literal>ISO_8859_5</literal>,
          <literal>KOI8R</literal>,
-         <literal>MULE_INTERNAL</literal>,
          <literal>UTF8</literal>,
          <literal>WIN1251</literal>
         </entry>
@@ -2683,7 +2646,6 @@ RESET client_encoding;
         <entry><literal>WIN1250</literal></entry>
         <entry><emphasis>WIN1250</emphasis>,
          <literal>LATIN2</literal>,
-         <literal>MULE_INTERNAL</literal>,
          <literal>UTF8</literal>
         </entry>
        </row>
@@ -2692,7 +2654,6 @@ RESET client_encoding;
         <entry><emphasis>WIN1251</emphasis>,
          <literal>ISO_8859_5</literal>,
          <literal>KOI8R</literal>,
-         <literal>MULE_INTERNAL</literal>,
          <literal>UTF8</literal>,
          <literal>WIN866</literal>
         </entry>
@@ -2775,31 +2736,16 @@ RESET client_encoding;
         <entry><literal>BIG5</literal></entry>
         <entry><literal>EUC_TW</literal></entry>
        </row>
-       <row>
-        <entry><literal>big5_to_mic</literal></entry>
-        <entry><literal>BIG5</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>big5_to_utf8</literal></entry>
         <entry><literal>BIG5</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>euc_cn_to_mic</literal></entry>
-        <entry><literal>EUC_CN</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>euc_cn_to_utf8</literal></entry>
         <entry><literal>EUC_CN</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>euc_jp_to_mic</literal></entry>
-        <entry><literal>EUC_JP</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>euc_jp_to_sjis</literal></entry>
         <entry><literal>EUC_JP</literal></entry>
@@ -2810,11 +2756,6 @@ RESET client_encoding;
         <entry><literal>EUC_JP</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>euc_kr_to_mic</literal></entry>
-        <entry><literal>EUC_KR</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>euc_kr_to_utf8</literal></entry>
         <entry><literal>EUC_KR</literal></entry>
@@ -2825,11 +2766,6 @@ RESET client_encoding;
         <entry><literal>EUC_TW</literal></entry>
         <entry><literal>BIG5</literal></entry>
        </row>
-       <row>
-        <entry><literal>euc_tw_to_mic</literal></entry>
-        <entry><literal>EUC_TW</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>euc_tw_to_utf8</literal></entry>
         <entry><literal>EUC_TW</literal></entry>
@@ -2870,21 +2806,11 @@ RESET client_encoding;
         <entry><literal>LATIN10</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>iso_8859_1_to_mic</literal></entry>
-        <entry><literal>LATIN1</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>iso_8859_1_to_utf8</literal></entry>
         <entry><literal>LATIN1</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>iso_8859_2_to_mic</literal></entry>
-        <entry><literal>LATIN2</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>iso_8859_2_to_utf8</literal></entry>
         <entry><literal>LATIN2</literal></entry>
@@ -2895,21 +2821,11 @@ RESET client_encoding;
         <entry><literal>LATIN2</literal></entry>
         <entry><literal>WIN1250</literal></entry>
        </row>
-       <row>
-        <entry><literal>iso_8859_3_to_mic</literal></entry>
-        <entry><literal>LATIN3</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>iso_8859_3_to_utf8</literal></entry>
         <entry><literal>LATIN3</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>iso_8859_4_to_mic</literal></entry>
-        <entry><literal>LATIN4</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>iso_8859_4_to_utf8</literal></entry>
         <entry><literal>LATIN4</literal></entry>
@@ -2920,11 +2836,6 @@ RESET client_encoding;
         <entry><literal>ISO_8859_5</literal></entry>
         <entry><literal>KOI8R</literal></entry>
        </row>
-       <row>
-        <entry><literal>iso_8859_5_to_mic</literal></entry>
-        <entry><literal>ISO_8859_5</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>iso_8859_5_to_utf8</literal></entry>
         <entry><literal>ISO_8859_5</literal></entry>
@@ -2970,11 +2881,6 @@ RESET client_encoding;
         <entry><literal>KOI8R</literal></entry>
         <entry><literal>ISO_8859_5</literal></entry>
        </row>
-       <row>
-        <entry><literal>koi8_r_to_mic</literal></entry>
-        <entry><literal>KOI8R</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>koi8_r_to_utf8</literal></entry>
         <entry><literal>KOI8R</literal></entry>
@@ -2995,91 +2901,11 @@ RESET client_encoding;
         <entry><literal>KOI8U</literal></entry>
         <entry><literal>UTF8</literal></entry>
        </row>
-       <row>
-        <entry><literal>mic_to_big5</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>BIG5</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_euc_cn</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>EUC_CN</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_euc_jp</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>EUC_JP</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_euc_kr</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>EUC_KR</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_euc_tw</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>EUC_TW</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_iso_8859_1</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>LATIN1</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_iso_8859_2</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>LATIN2</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_iso_8859_3</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>LATIN3</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_iso_8859_4</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>LATIN4</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_iso_8859_5</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>ISO_8859_5</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_koi8_r</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>KOI8R</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_sjis</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>SJIS</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_windows_1250</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>WIN1250</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_windows_1251</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>WIN1251</literal></entry>
-       </row>
-       <row>
-        <entry><literal>mic_to_windows_866</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-        <entry><literal>WIN866</literal></entry>
-       </row>
        <row>
         <entry><literal>sjis_to_euc_jp</literal></entry>
         <entry><literal>SJIS</literal></entry>
         <entry><literal>EUC_JP</literal></entry>
        </row>
-       <row>
-        <entry><literal>sjis_to_mic</literal></entry>
-        <entry><literal>SJIS</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>sjis_to_utf8</literal></entry>
         <entry><literal>SJIS</literal></entry>
@@ -3285,11 +3111,6 @@ RESET client_encoding;
         <entry><literal>WIN1250</literal></entry>
         <entry><literal>LATIN2</literal></entry>
        </row>
-       <row>
-        <entry><literal>windows_1250_to_mic</literal></entry>
-        <entry><literal>WIN1250</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>windows_1250_to_utf8</literal></entry>
         <entry><literal>WIN1250</literal></entry>
@@ -3305,11 +3126,6 @@ RESET client_encoding;
         <entry><literal>WIN1251</literal></entry>
         <entry><literal>KOI8R</literal></entry>
        </row>
-       <row>
-        <entry><literal>windows_1251_to_mic</literal></entry>
-        <entry><literal>WIN1251</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>windows_1251_to_utf8</literal></entry>
         <entry><literal>WIN1251</literal></entry>
@@ -3340,11 +3156,6 @@ RESET client_encoding;
         <entry><literal>WIN866</literal></entry>
         <entry><literal>KOI8R</literal></entry>
        </row>
-       <row>
-        <entry><literal>windows_866_to_mic</literal></entry>
-        <entry><literal>WIN866</literal></entry>
-        <entry><literal>MULE_INTERNAL</literal></entry>
-       </row>
        <row>
         <entry><literal>windows_866_to_utf8</literal></entry>
         <entry><literal>WIN866</literal></entry>
diff --git a/src/backend/utils/mb/conv.c b/src/backend/utils/mb/conv.c
index 5439d0940d1..79238bf6647 100644
--- a/src/backend/utils/mb/conv.c
+++ b/src/backend/utils/mb/conv.c
@@ -74,244 +74,6 @@ local2local(const unsigned char *l,
 	return l - start;
 }
 
-/*
- * LATINn ---> MIC when the charset's local codes map directly to MIC
- *
- * l points to the source string of length len
- * p is the output area (must be large enough!)
- * lc is the mule character set id for the local encoding
- * encoding is the PG identifier for the local encoding
- *
- * Returns the number of input bytes consumed.  If noError is true, this can
- * be less than 'len'.
- */
-int
-latin2mic(const unsigned char *l, unsigned char *p, int len,
-		  int lc, int encoding, bool noError)
-{
-	const unsigned char *start = l;
-	int			c1;
-
-	while (len > 0)
-	{
-		c1 = *l;
-		if (c1 == 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(encoding, (const char *) l, len);
-		}
-		if (IS_HIGHBIT_SET(c1))
-			*p++ = lc;
-		*p++ = c1;
-		l++;
-		len--;
-	}
-	*p = '\0';
-
-	return l - start;
-}
-
-/*
- * MIC ---> LATINn when the charset's local codes map directly to MIC
- *
- * mic points to the source string of length len
- * p is the output area (must be large enough!)
- * lc is the mule character set id for the local encoding
- * encoding is the PG identifier for the local encoding
- *
- * Returns the number of input bytes consumed.  If noError is true, this can
- * be less than 'len'.
- */
-int
-mic2latin(const unsigned char *mic, unsigned char *p, int len,
-		  int lc, int encoding, bool noError)
-{
-	const unsigned char *start = mic;
-	int			c1;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (c1 == 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL, (const char *) mic, len);
-		}
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* easy for ASCII */
-			*p++ = c1;
-			mic++;
-			len--;
-		}
-		else
-		{
-			int			l = pg_mule_mblen(mic);
-
-			if (len < l)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL, (const char *) mic,
-										len);
-			}
-			if (l != 2 || c1 != lc || !IS_HIGHBIT_SET(mic[1]))
-			{
-				if (noError)
-					break;
-				report_untranslatable_char(PG_MULE_INTERNAL, encoding,
-										   (const char *) mic, len);
-			}
-			*p++ = mic[1];
-			mic += 2;
-			len -= 2;
-		}
-	}
-	*p = '\0';
-
-	return mic - start;
-}
-
-
-/*
- * latin2mic_with_table: a generic single byte charset encoding
- * conversion from a local charset to the mule internal code.
- *
- * l points to the source string of length len
- * p is the output area (must be large enough!)
- * lc is the mule character set id for the local encoding
- * encoding is the PG identifier for the local encoding
- * tab holds conversion entries for the local charset
- * starting from 128 (0x80). each entry in the table holds the corresponding
- * code point for the mule encoding, or 0 if there is no equivalent code.
- *
- * Returns the number of input bytes consumed.  If noError is true, this can
- * be less than 'len'.
- */
-int
-latin2mic_with_table(const unsigned char *l,
-					 unsigned char *p,
-					 int len,
-					 int lc,
-					 int encoding,
-					 const unsigned char *tab,
-					 bool noError)
-{
-	const unsigned char *start = l;
-	unsigned char c1,
-				c2;
-
-	while (len > 0)
-	{
-		c1 = *l;
-		if (c1 == 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(encoding, (const char *) l, len);
-		}
-		if (!IS_HIGHBIT_SET(c1))
-			*p++ = c1;
-		else
-		{
-			c2 = tab[c1 - HIGHBIT];
-			if (c2)
-			{
-				*p++ = lc;
-				*p++ = c2;
-			}
-			else
-			{
-				if (noError)
-					break;
-				report_untranslatable_char(encoding, PG_MULE_INTERNAL,
-										   (const char *) l, len);
-			}
-		}
-		l++;
-		len--;
-	}
-	*p = '\0';
-
-	return l - start;
-}
-
-/*
- * mic2latin_with_table: a generic single byte charset encoding
- * conversion from the mule internal code to a local charset.
- *
- * mic points to the source string of length len
- * p is the output area (must be large enough!)
- * lc is the mule character set id for the local encoding
- * encoding is the PG identifier for the local encoding
- * tab holds conversion entries for the mule internal code's second byte,
- * starting from 128 (0x80). each entry in the table holds the corresponding
- * code point for the local charset, or 0 if there is no equivalent code.
- *
- * Returns the number of input bytes consumed.  If noError is true, this can
- * be less than 'len'.
- */
-int
-mic2latin_with_table(const unsigned char *mic,
-					 unsigned char *p,
-					 int len,
-					 int lc,
-					 int encoding,
-					 const unsigned char *tab,
-					 bool noError)
-{
-	const unsigned char *start = mic;
-	unsigned char c1,
-				c2;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (c1 == 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL, (const char *) mic, len);
-		}
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* easy for ASCII */
-			*p++ = c1;
-			mic++;
-			len--;
-		}
-		else
-		{
-			int			l = pg_mule_mblen(mic);
-
-			if (len < l)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL, (const char *) mic,
-										len);
-			}
-			if (l != 2 || c1 != lc || !IS_HIGHBIT_SET(mic[1]) ||
-				(c2 = tab[mic[1] - HIGHBIT]) == 0)
-			{
-				if (noError)
-					break;
-				report_untranslatable_char(PG_MULE_INTERNAL, encoding,
-										   (const char *) mic, len);
-				break;			/* keep compiler quiet */
-			}
-			*p++ = c2;
-			mic += 2;
-			len -= 2;
-		}
-	}
-	*p = '\0';
-
-	return mic - start;
-}
-
 /*
  * comparison routine for bsearch()
  * this routine is intended for combined UTF8 -> local code
diff --git a/src/backend/utils/mb/conversion_procs/Makefile b/src/backend/utils/mb/conversion_procs/Makefile
index bcadf6688d6..d3c49275a15 100644
--- a/src/backend/utils/mb/conversion_procs/Makefile
+++ b/src/backend/utils/mb/conversion_procs/Makefile
@@ -14,8 +14,8 @@ top_builddir = ../../../../..
 include $(top_builddir)/src/Makefile.global
 
 SUBDIRS = \
-	cyrillic_and_mic euc_cn_and_mic euc_jp_and_sjis \
-	euc_kr_and_mic euc_tw_and_big5 latin2_and_win1250 latin_and_mic \
+	cyrillic euc_jp_and_sjis \
+	euc_tw_and_big5 latin2_and_win1250 \
 	utf8_and_big5 utf8_and_cyrillic utf8_and_euc_cn \
 	utf8_and_euc_jp utf8_and_euc_kr utf8_and_euc_tw utf8_and_gb18030 \
 	utf8_and_gbk utf8_and_iso8859 utf8_and_iso8859_1 utf8_and_johab \
diff --git a/src/backend/utils/mb/conversion_procs/latin_and_mic/Makefile b/src/backend/utils/mb/conversion_procs/cyrillic/Makefile
similarity index 57%
rename from src/backend/utils/mb/conversion_procs/latin_and_mic/Makefile
rename to src/backend/utils/mb/conversion_procs/cyrillic/Makefile
index c404738d2f6..1ad04c20300 100644
--- a/src/backend/utils/mb/conversion_procs/latin_and_mic/Makefile
+++ b/src/backend/utils/mb/conversion_procs/cyrillic/Makefile
@@ -1,13 +1,13 @@
 #-------------------------------------------------------------------------
 #
-# src/backend/utils/mb/conversion_procs/latin_and_mic/Makefile
+# src/backend/utils/mb/conversion_procs/cyrillic/Makefile
 #
 #-------------------------------------------------------------------------
-subdir = src/backend/utils/mb/conversion_procs/latin_and_mic
+subdir = src/backend/utils/mb/conversion_procs/cyrillic
 top_builddir = ../../../../../..
 include $(top_builddir)/src/Makefile.global
 
-NAME		= latin_and_mic
-PGFILEDESC	= "latin <-> mic text conversions"
+NAME		= cyrillic
+PGFILEDESC	= "cyrillic single-byte conversions"
 
 include $(srcdir)/../proc.mk
